# autogenerated by ssc-gen DO NOT_EDIT

import re
import json
from typing import List, Dict, TypedDict, Union
from contextlib import suppress


from parsel import Selector, SelectorList

J_AggregateRating = TypedDict(
    "J_AggregateRating",
    {
        "type": str,
        "ratingCount": int,
        "bestRating": int,
        "ratingValue": str,
    },
)
J_Director = TypedDict(
    "J_Director",
    {
        "type": str,
        "url": str,
        "name": str,
    },
)
J_Actor = TypedDict(
    "J_Actor",
    {
        "type": str,
        "url": str,
        "name": str,
    },
)
J_Creator = TypedDict(
    "J_Creator",
    {
        "type": str,
        "url": str,
        "name": str,
    },
)
J_Content = TypedDict(
    "J_Content",
    {
        "context": str,
        "type": str,
        "url": str,
        "name": str,
        "contentRating": str,
        "description": str,
        "aggregateRating": J_AggregateRating,
        "startDate": str,
        "image": str,
        "genre": List[str],
        "alternativeHeadline": List[str],
        "director": List[J_Director],
        "actor": List[J_Actor],
        "creator": List[J_Creator],
    },
)
T_OngoingPage = TypedDict(
    "T_OngoingPage",
    {
        "url": str,
        "title": str,
        "thumbnail": str,
        "episode": str,
        "dub": str,
    },
)
T_SearchPage = TypedDict(
    "T_SearchPage",
    {
        "title": str,
        "thumbnail": str,
        "url": str,
    },
)
T_AnimePage = TypedDict(
    "T_AnimePage",
    {
        "title": str,
        "description": str,
        "thumbnail": str,
        "id": str,
        "raw_json": J_Content,
    },
)
T_EpisodeDubbersView = Dict[str, str]
T_EpisodesView = TypedDict(
    "T_EpisodesView",
    {
        "num": str,
        "title": str,
        "id": str,
    },
)
T_EpisodePage = TypedDict(
    "T_EpisodePage",
    {
        "dubbers": T_EpisodeDubbersView,
        "episodes": List[T_EpisodesView],
    },
)
T_EpisodeVideoPlayersView = TypedDict(
    "T_EpisodeVideoPlayersView",
    {
        "player": str,
        "data_provider": str,
        "data_provide_dubbing": str,
    },
)
T_EpisodeVideoDubbersView = Dict[str, str]
T_EpisodeVideoPage = TypedDict(
    "T_EpisodeVideoPage",
    {
        "dubbers": T_EpisodeVideoDubbersView,
        "videos": List[T_EpisodeVideoPlayersView],
    },
)
T_SourceVideoView = TypedDict(
    "T_SourceVideoView",
    {
        "title": str,
        "url": str,
        "data_provider": str,
        "data_provide_dubbing": str,
    },
)
T_SourceDubbersView = Dict[str, str]
T_SourcePage = TypedDict(
    "T_SourcePage",
    {
        "dubbers": T_SourceDubbersView,
        "videos": List[T_SourceVideoView],
    },
)


class OngoingPage:
    """Get all available ongoings from the main page

        GET https://animego.one


    [
        {
            "url": "String",
            "title": "String",
            "thumbnail": "String",
            "episode": "String",
            "dub": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css(".border-bottom-0.cursor-pointer")

    def _parse_url(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.attrib["onclick"]
        v1 = v0[len("location.href=") :] if v0.startswith("location.href=") else v0
        v2 = v1.strip("'")
        return f"https://animego.one{v2}"

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".last-update-title")
        return "".join(v0.css("::text").getall())

    def _parse_thumbnail(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".lazy[style]")
        v1 = v0.attrib["style"]
        v2 = v1[len("background-image: url(") :] if v1.startswith("background-image: url(") else v1
        return v2.rstrip(");")

    def _parse_episode(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".text-truncate")
        v1 = "".join(v0.css("::text").getall())
        return re.search(r"(\d+)\s", v1)[1]

    def _parse_dub(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".text-gray-dark-6")
        v1 = "".join(v0.css("::text").getall())
        v2 = v1.replace(")", "")
        return v2.replace("(", "")

    def parse(self) -> List[T_OngoingPage]:
        return [
            {
                "url": self._parse_url(el),
                "title": self._parse_title(el),
                "thumbnail": self._parse_thumbnail(el),
                "episode": self._parse_episode(el),
                "dub": self._parse_dub(el),
            }
            for el in self._split_doc(self._document)
        ]


class SearchPage:
    """Get all search results by query

        USAGE:

            GET https://animego.one/search/anime
            q={QUERY}

        EXAMPLE:

            GET https://animego.one/search/anime?q=LAIN


    [
        {
            "title": "String",
            "thumbnail": "String",
            "url": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css(".row > .col-ul-2")

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".text-truncate a[title]")
        return v0.attrib["title"]

    def _parse_thumbnail(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".lazy[data-original]")
        return v0.attrib["data-original"]

    def _parse_url(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".text-truncate a[href]")
        return v0.attrib["href"]

    def parse(self) -> List[T_SearchPage]:
        return [
            {
                "title": self._parse_title(el),
                "thumbnail": self._parse_thumbnail(el),
                "url": self._parse_url(el),
            }
            for el in self._split_doc(self._document)
        ]


class AnimePage:
    """Anime page information. anime path contains in SearchView.url or Ongoing.url

        - id needed for next API requests
        - raw_json used for extract extra metadata (unescape required)

        USAGE:

            GET https://animego.one/anime/<ANIME_PATH>

        EXAMPLE:

            GET https://animego.one/anime/eksperimenty-leyn-1114


    {
        "title": "String",
        "description": "String",
        "thumbnail": "String",
        "id": "String",
        "raw_json": {
            "context": "String",
            "type": "String",
            "url": "String",
            "name": "String",
            "contentRating": "String",
            "description": "String",
            "aggregateRating": {
                "type": "String",
                "ratingCount": "Int",
                "bestRating": "Int",
                "ratingValue": "String"
            },
            "startDate": "String",
            "image": "String",
            "genre": "Array<String>",
            "alternativeHeadline": "Array<String>",
            "director": [
                {
                    "type": "String",
                    "url": "String",
                    "name": "String"
                },
                "..."
            ],
            "actor": [
                {
                    "type": "String",
                    "url": "String",
                    "name": "String"
                },
                "..."
            ],
            "creator": [
                {
                    "type": "String",
                    "url": "String",
                    "name": "String"
                },
                "..."
            ]
        }
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".anime-title h1")
        return "".join(v0.css("::text").getall())

    def _parse_description(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v
        with suppress(Exception):
            v1 = v0.css(".description")
            v2 = v1.css("::text").getall()
            v3 = "".join(v2)
            return re.sub(r"^\s+|\s+$", "", v3)
        return ""

    def _parse_thumbnail(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css("#content img")
        return v0.attrib["src"]

    def _parse_id(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".br-2 .my-list-anime")
        v1 = v0.attrib["id"]
        return v1.lstrip("my-list-")

    def _parse_raw_json(self, v: Union[Selector, SelectorList]) -> J_Content:
        v0 = v.css("script[type='application/ld+json']")
        v1 = "".join(v0.css("::text").getall())
        v2 = v1.replace('"@type"', '"type"')
        v3 = v2.replace('"@context"', '"context"')
        return json.loads(v3)

    def parse(self) -> T_AnimePage:
        return {
            "title": self._parse_title(self._document),
            "description": self._parse_description(self._document),
            "thumbnail": self._parse_thumbnail(self._document),
            "id": self._parse_id(self._document),
            "raw_json": self._parse_raw_json(self._document),
        }


class EpisodeDubbersView:
    """

    {
        "<dubber_id>": "<dubber_name>",
        "<id>": "..."
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-dubbing .mb-1")

    def _parse_key(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-dubbing"]

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css("span")
        v1 = "".join(v0.css("::text").getall())
        return re.sub(r"^\s+|\s+$", "", v1)

    def parse(self) -> T_EpisodeDubbersView:
        return {self._parse_key(el): self._parse_value(el) for el in self._split_doc(self._document)}


class EpisodesView:
    """

    [
        {
            "num": "String",
            "title": "String",
            "id": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-carousel .mb-0")

    def _parse_num(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-episode"]

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-episode-title"]

    def _parse_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-id"]

    def parse(self) -> List[T_EpisodesView]:
        return [
            {
                "num": self._parse_num(el),
                "title": self._parse_title(el),
                "id": self._parse_id(el),
            }
            for el in self._split_doc(self._document)
        ]


class EpisodePage:
    """Representation episodes

        NOTE:
            film pages does not exist video-carousel feature: test by `#video-carousel` CSS selector
            or match by '<div id="video-carousel"' substring

        Prepare:
          1. get id from Anime object
          2. GET 'https://animego.one/anime/{Anime.id}/player?_allow=true'
          3. extract html from json by ['content'] key
          4. OPTIONAL: unescape HTML

        EXAMPLE:
            GET https://animego.one/anime/anime/1114//player?_allow=true


    {
        "dubbers": {
            "<dubber_id>": "<dubber_name>",
            "<id>": "..."
        },
        "episodes": [
            {
                "num": "String",
                "title": "String",
                "id": "String"
            },
            "..."
        ]
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_dubbers(self, v: Union[Selector, SelectorList]) -> T_EpisodeDubbersView:
        return EpisodeDubbersView(v).parse()

    def _parse_episodes(self, v: Union[Selector, SelectorList]) -> List[T_EpisodesView]:
        return EpisodesView(v).parse()

    def parse(self) -> T_EpisodePage:
        return {
            "dubbers": self._parse_dubbers(self._document),
            "episodes": self._parse_episodes(self._document),
        }


class EpisodeVideoPlayersView:
    """

    [
        {
            "player": "String",
            "data_provider": "String",
            "data_provide_dubbing": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-players > .mb-1")

    def _parse_player(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.attrib["data-player"]
        v1 = re.sub("^https?", "", v0)
        return f"https:{v1}"

    def _parse_data_provider(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-provider"]

    def _parse_data_provide_dubbing(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.attrib["data-provide-dubbing"]
        v1 = re.sub("^/s*", "", v0)
        return re.sub(r"/s*$", "", v1)

    def parse(self) -> List[T_EpisodeVideoPlayersView]:
        return [
            {
                "player": self._parse_player(el),
                "data_provider": self._parse_data_provider(el),
                "data_provide_dubbing": self._parse_data_provide_dubbing(el),
            }
            for el in self._split_doc(self._document)
        ]


class EpisodeVideoDubbersView:
    """

    {
        "<dubber_id>": "<dubber_name>",
        "<id>": "..."
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-dubbing .mb-1")

    def _parse_key(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-dubbing"]

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css("span")
        v1 = "".join(v0.css("::text").getall())
        return re.sub(r"^\s+|\s+$", "", v1)

    def parse(self) -> T_EpisodeVideoDubbersView:
        return {self._parse_key(el): self._parse_value(el) for el in self._split_doc(self._document)}


class EpisodeVideoPage:
    """Represent Episode object for film (it have not same signatures)

        NOTE:
            film pages does not exist video-carousel feature: test by `#video-carousel` CSS selector
            or match by '<div id="video-carousel"' substring

        Prepare:
          1. get id from Anime object
          2. GET 'https://animego.one/anime/{Anime.id}/player?_allow=true'
          3. extract html from json by ['content'] key
          4. OPTIONAL: unescape HTML

        EXAMPLE:
            GET https://animego.one/anime/315/player?_allow=true


    {
        "dubbers": {
            "<dubber_id>": "<dubber_name>",
            "<id>": "..."
        },
        "videos": [
            {
                "player": "String",
                "data_provider": "String",
                "data_provide_dubbing": "String"
            },
            "..."
        ]
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_dubbers(self, v: Union[Selector, SelectorList]) -> T_EpisodeVideoDubbersView:
        return EpisodeVideoDubbersView(v).parse()

    def _parse_videos(self, v: Union[Selector, SelectorList]) -> List[T_EpisodeVideoPlayersView]:
        return EpisodeVideoPlayersView(v).parse()

    def parse(self) -> T_EpisodeVideoPage:
        return {
            "dubbers": self._parse_dubbers(self._document),
            "videos": self._parse_videos(self._document),
        }


class SourceVideoView:
    """

    [
        {
            "title": "String",
            "url": "String",
            "data_provider": "String",
            "data_provide_dubbing": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-players > span")

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        return "".join(v.css("::text").getall())

    def _parse_url(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.attrib["data-player"]
        return f"https:{v0}"

    def _parse_data_provider(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-provider"]

    def _parse_data_provide_dubbing(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-provide-dubbing"]

    def parse(self) -> List[T_SourceVideoView]:
        return [
            {
                "title": self._parse_title(el),
                "url": self._parse_url(el),
                "data_provider": self._parse_data_provider(el),
                "data_provide_dubbing": self._parse_data_provide_dubbing(el),
            }
            for el in self._split_doc(self._document)
        ]


class SourceDubbersView:
    """

    {
        "<dubber_id>": "<dubber_name>",
        "...": "..."
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("#video-dubbing > span")

    def _parse_key(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-dubbing"]

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        v0 = "".join(v.css("::text").getall())
        v1 = re.sub("^\\s+", "", v0)
        return re.sub(r"\s+$", "", v1)

    def parse(self) -> T_SourceDubbersView:
        return {self._parse_key(el): self._parse_value(el) for el in self._split_doc(self._document)}


class SourcePage:
    """representation player urls

        Prepare:
          1. get num and id from Episode

          2.

          GET https://animego.one/anime/series
          dubbing=2&provider=24&episode={Episode.num}id={Episode.id}

          3. extract html from json by ["content"] key

          4. OPTIONAL: unescape document

        EXAMPLE:

            GET https://animego.one/anime/series?dubbing=2&provider=24&episode=2&id=15837


    {
        "dubbers": {
            "<dubber_id>": "<dubber_name>",
            "...": "..."
        },
        "videos": [
            {
                "title": "String",
                "url": "String",
                "data_provider": "String",
                "data_provide_dubbing": "String"
            },
            "..."
        ]
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_dubbers(self, v: Union[Selector, SelectorList]) -> T_SourceDubbersView:
        return SourceDubbersView(v).parse()

    def _parse_videos(self, v: Union[Selector, SelectorList]) -> List[T_SourceVideoView]:
        return SourceVideoView(v).parse()

    def parse(self) -> T_SourcePage:
        return {
            "dubbers": self._parse_dubbers(self._document),
            "videos": self._parse_videos(self._document),
        }
