# autogenerated by ssc-gen DO NOT_EDIT
"""Thanks https://github.com/barsikus007 for researches and decoder impl

NOTE: for extract Search and Ongoing items use rest-api requests:

Ongoing:

POST https://dreamerscast.com/"

{'search': "", "status": "", "pageSize": 16, 'pageNumber': 1}

Search:

POST https://dreamerscast.com/"

{'search': "<QUERY>", "status": "", "pageSize": 16, 'pageNumber': 1}
"""

import re
from typing import TypedDict, Union, Optional
from contextlib import suppress


from parsel import Selector, SelectorList

T_AnimePage = TypedDict(
    "T_AnimePage",
    {
        "title": str,
        "description": Optional[str],
        "thumbnail": str,
        "player_js_encoded": str,
        "player_js_url": str,
    },
)


class AnimePage:
    """

        Usage example:

        GET https://dreamerscast.com/home/release/323-tensei-kizoku-kantei-skill-de-nariagaru-2

        Encoding (24.12.24 actual step-by-step)

        decoding and extract playlist:

        - GET <player_js_url>
        - unpack, extract encoded symbols
        - by <player_js_encoded> and <player_js_url> values decrypt it (implement logic from original source code)


    {
        "title": "String",
        "description": "String",
        "thumbnail": "String",
        "player_js_encoded": "String",
        "player_js_url": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_title(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css("h3")
        return "".join(v0.css("::text").getall())

    def _parse_description(self, v: Union[Selector, SelectorList]) -> Optional[str]:
        v0 = v
        with suppress(Exception):
            v1 = v0.css(".postDesc")
            return "".join(v1.css("::text").getall())
        return None

    def _parse_thumbnail(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.css(".details_poster img")
        v1 = v0.attrib["src"]
        return f"https:{v1}"

    def _parse_player_js_encoded(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r'new Playerjs\("(.*?)"\)', v0)[1]

    def _parse_player_js_url(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        v1 = re.search('<script[^>]+src="(/js/playerjs.*?)"', v0)[1]
        return f"https://dreamerscast.com{v1}"

    def parse(self) -> T_AnimePage:
        return {
            "title": self._parse_title(self._document),
            "description": self._parse_description(self._document),
            "thumbnail": self._parse_thumbnail(self._document),
            "player_js_encoded": self._parse_player_js_encoded(self._document),
            "player_js_url": self._parse_player_js_url(self._document),
        }
